function [x,iter,err]=iterative(P,q,x0,tol,kmax)
%-----------------------------------------
% generic iterative method x_k+1=Px_k+q 
% for the solution of linear system
%-------------------------------------------
x1=P*x0+q; 
iter=1;
err(iter)=norm(x1-x0)/norm(x1);

while( err(iter) > tol && iter <= kmax)
    x0=x1;
    x1=P*x0+q;
    iter=iter+1;
    err(iter)=norm(x1-x0)/norm(x1);
end
x=x1; iter=iter-1;
